#include<avr/io.h>
#include<avr/interrupt.h>
#include <util/delay.h>
#define F_CPU 16000000
#include "Nokia5110.h"

#define LINE_DIST 10
#define LINE_SEG_LEN 8
#define NR_SEG 6
#define MAX_NUM_LINES 6

#define LEFT 1
#define RIGHT 2
#define UP 3
#define DOWN 4

#define S_WIDTH 47
#define S_HEIGHT 60

#define D_HEIGHT 83

char lost;
int on_screen_lines;
int line_pass;
int iter;
int scor,delay_time;

struct position {
	int x;
	int y;
};

struct line {
	int height;
	int gap;

};

struct position ball;

struct line lines[MAX_NUM_LINES];


void move_scene_up(){

	int i = 0;

	for (i = 0; i < MAX_NUM_LINES; i++)
		lines[i].height += 1;

	ball.x +=1;
}


void delay_frame()
{
	volatile int i;

	for (i = 0; i < delay_time; i++) {}

	if (delay_time > 0)
		delay_time -= 50;
}

void move_ball(int dir){

	switch (dir){
		case LEFT : {
			if (ball.y < S_WIDTH - 3){
				ball.y += 1;
			}
		} break;
		case RIGHT : {
			if (ball.y > 3){
				ball.y -= 1;
			}

		} break;

		case DOWN : {
			ball.x -= 1;
		} break;
	}
}

void check_moves(){

	int i;
	char ok = 1;

	scor += 5;
	if (S_HEIGHT-ball.x <= 6) {
		lost = 1;
		return;
	}

	if (ball.x > LINE_DIST + 1) {

		for (i = 0; i < on_screen_lines; i++) {
			if (lines[i].height == ball.x - 1) {
				if (((lines[i].gap + 1) * LINE_SEG_LEN > ball.y) && (lines[i].gap * LINE_SEG_LEN < ball.y)){
					scor += 50;}
					else {
						ok = 0;
					}
			}
		}

		if (ok == 1){
			move_ball(DOWN);
		}
	}

	if (!(PINB&(1<<PB0))) {move_ball(LEFT);}

	if (!(PINB&(1<<PB1))) {move_ball(RIGHT);}
}

void generate_line(){
	int gap = rand() % NR_SEG;
	int i;

	if(on_screen_lines== MAX_NUM_LINES){

		for(i=0;i<MAX_NUM_LINES-1;i++){
	
			lines[i].height = lines[i+1].height;
			lines[i].gap = lines[i+1].gap;
		}

		lines[MAX_NUM_LINES-1].height = 0;
		lines[MAX_NUM_LINES-1].gap = gap;

	}
	else{
		on_screen_lines++;
		lines[on_screen_lines].height = 0;
		lines[on_screen_lines].gap = gap;
		
	}


}

void draw_scene(){
int i,j,k;

	


	//DESEN CHENAR
	
	for(i=0;i<S_WIDTH;i++)
	{
		lcd_setpixel(D_HEIGHT-S_HEIGHT,i);
		lcd_setpixel(D_HEIGHT-S_HEIGHT-1,i);
	}
	
	
	//DESENAREA LINIILOR
	for(i=0;i<on_screen_lines;i++){
		for(j=0;j<NR_SEG;j++){
			if(j!=lines[i].gap){
				for(k=0;k<LINE_SEG_LEN;k++){
					lcd_setpixel(D_HEIGHT-lines[i].height,
								k+(j*LINE_SEG_LEN));
				
				}
			}
		}
	}
	
	//DESENAREA BILEI
	

	for(i=0;i<3;i++){
		lcd_setpixel(D_HEIGHT-ball.x -i ,ball.y);
		lcd_setpixel(D_HEIGHT-ball.x-5 +i,ball.y);
		
		for(j=0;j<i;j++){
			lcd_setpixel(D_HEIGHT-ball.x +i-5 ,ball.y+j);
			lcd_setpixel(D_HEIGHT-ball.x +i-5 ,ball.y-j);
			lcd_setpixel(D_HEIGHT-ball.x -i,ball.y+j);
			lcd_setpixel(D_HEIGHT-ball.x -i,ball.y-j);
		}
	}	

}

void init_game() {
	on_screen_lines = -1;
	ball.x = 15;
	ball.y = 24;
	iter = 0;
	line_pass =0;
	scor=0;
	delay_time=0;
}

void display_score(){
	lcd_clear();
	lcd_update();
	lcd_gotoXY(24, 1);
	lcd_str("SCOR", 4);
	lcd_gotoXY(24, 3);
	
	
	int poz = 24;
	while(scor>0){
	LCD_write_char(scor%10+'1'-1);
	poz+=10;
	lcd_gotoXY(poz,3);
	scor=scor/10;
	}

	//lcd_update();
	_delay_ms(1500000);
}

void wait_for_start(){

	display_score();
	while(!(!(PINB & (1<<PB2)))){
		
	}
	lcd_gotoXY(42, 2);	
	lcd_str("haha", 4);

}

int main(void){
	lost = 0;

	//init_game();
	LCD_init();
	DDRB &= ~((1 << PB0) | (1 << PB1) | (1 << PB2));
	PORTB |= (1 << PB0) | (1 << PB1) | (1 << PB2);
	
	lcd_clear();
	lcd_update();
	lcd_gotoXY(24, 1);	
	lcd_str("FALL", 4);
	lcd_gotoXY(42, 2);	
	lcd_str("DOWN", 4);

	_delay_ms(1000);
	
	while(1) {
	
		if(lost == 1){
			wait_for_start();
			lost = 0;
			init_game();
		}
	
		while(lost == 0){
			lcd_clear();
		
			if (iter%2 == 0){ //bila se poate deplasa
		
				check_moves();
		
			}
		
			if(iter == 2){ //liniile se vor deplasa
		
				if(line_pass == LINE_DIST){
			
					generate_line();
					line_pass =0;
				
				}
			move_scene_up();	
			line_pass++;
			}
		
		
			iter++;
			if (iter == 4){
				iter =0;
			}
			draw_scene();
			lcd_setpixel(83,0);
		
			lcd_update();
			_delay_ms(100);
		}

	}

	return 1;
}
